#include "squidwall.h"

/**
 * Copyright (C) 2005-2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/**
 * url whitelist checking
 */

int check_wlist(void)
{
	struct squidwall_string *string;
	struct list_head *l;
	unsigned int j, k;
	char *file, *str;

	if (wfilter_host)
	for (j=0; j < wfilter_host->len; j += str_len(wfilter_host->s+j)+1)
	list_for_each(l, &wfilter) {
		string = list_entry(l, struct squidwall_string, list);
		file = wfilter_host->s+j;
		if (str_equal(file, string->filename.s))
		for (k=0; k < string->strings.len;
				k += str_len(string->strings.s+k)+1) {
			str = string->strings.s+k;
			if (case_strstr(squid_url, str)) {
				return ACL_ALLOW;
			}
		}
	}

	if (wfilter_user)
	for (j=0; j < wfilter_user->len; j += str_len(wfilter_user->s+j)+1)
	list_for_each(l, &wfilter) {
		string = list_entry(l, struct squidwall_string, list);
		file = wfilter_user->s+j;
		if (str_equal(file, string->filename.s))
		for (k=0; k < string->strings.len;
				k += str_len(string->strings.s+k)+1) {
			str = string->strings.s+k;
			if (case_strstr(squid_url, str)) {
				return ACL_ALLOW;
			}
		}
	}

	return ACL_DENY;
}
