
/**
 * Copyright (C) 2005 - 2013 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdlib.h>

#include "params.h"
#include "timestamp.h"

#if WANT_TAI64_LOGFILES
#include "hextab.h"
#include "taia.h"

/* @40000000516fa2a337248de4 -> 25 Zeichen */
void timestamp(char s[TIMESTAMP])
{
	struct taia now;
	char nowpack[TAIA_PACK];
	int i;

	taia_now(&now);
	taia_pack(nowpack,&now);

	s[0] = '@';
	for (i = 0;i < 12;++i) {
		s[i * 2 + 1] = hextab[(nowpack[i] >> 4) & 15];
		s[i * 2 + 2] = hextab[nowpack[i] & 15];
	}

	return;
}

#else
#include <time.h>

/* 2012-12-31 12:11:10 -> 19 Zeichen */
void timestamp(char s[TIMESTAMP])
{
	struct tm *tm;
	time_t t;
	int i;

	t = time(0);
	tm = localtime(&t);

	if (tm == NULL)
		exit(111);

	if (strftime(s, TIMESTAMP, "%Y-%m-%d %H:%M:%S", tm) == 0)
		exit(111);

	return;
}

#endif
